# coding: utf-8

"""
    Alertmanager API

    API of the Prometheus Alertmanager (https://github.com/prometheus/alertmanager)  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from prometheus_icinga_exporter.alertmanager_client.api_client import ApiClient
from prometheus_icinga_exporter.alertmanager_client.exceptions import ApiTypeError, ApiValueError  # noqa: F401


class AlertApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_alerts(self, **kwargs):  # noqa: E501
        """get_alerts  # noqa: E501

        Get a list of alerts  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_alerts(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param bool active: Show active alerts
        :param bool silenced: Show silenced alerts
        :param bool inhibited: Show inhibited alerts
        :param bool unprocessed: Show unprocessed alerts
        :param list[str] filter: A list of matchers to filter alerts by
        :param str receiver: A regex matching receivers to filter alerts by
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: list[GettableAlert]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        return self.get_alerts_with_http_info(**kwargs)  # noqa: E501

    def get_alerts_with_http_info(self, **kwargs):  # noqa: E501
        """get_alerts  # noqa: E501

        Get a list of alerts  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_alerts_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param bool active: Show active alerts
        :param bool silenced: Show silenced alerts
        :param bool inhibited: Show inhibited alerts
        :param bool unprocessed: Show unprocessed alerts
        :param list[str] filter: A list of matchers to filter alerts by
        :param str receiver: A regex matching receivers to filter alerts by
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(list[GettableAlert], status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ["active", "silenced", "inhibited", "unprocessed", "filter", "receiver"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method get_alerts" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]

        collection_formats = {}

        path_params = {}

        query_params = []
        if "active" in local_var_params and local_var_params["active"] is not None:  # noqa: E501
            query_params.append(("active", local_var_params["active"]))  # noqa: E501
        if "silenced" in local_var_params and local_var_params["silenced"] is not None:  # noqa: E501
            query_params.append(("silenced", local_var_params["silenced"]))  # noqa: E501
        if "inhibited" in local_var_params and local_var_params["inhibited"] is not None:  # noqa: E501
            query_params.append(("inhibited", local_var_params["inhibited"]))  # noqa: E501
        if "unprocessed" in local_var_params and local_var_params["unprocessed"] is not None:  # noqa: E501
            query_params.append(("unprocessed", local_var_params["unprocessed"]))  # noqa: E501
        if "filter" in local_var_params and local_var_params["filter"] is not None:  # noqa: E501
            query_params.append(("filter", local_var_params["filter"]))  # noqa: E501
            collection_formats["filter"] = "multi"  # noqa: E501
        if "receiver" in local_var_params and local_var_params["receiver"] is not None:  # noqa: E501
            query_params.append(("receiver", local_var_params["receiver"]))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["application/json"])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/alerts",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type="list[GettableAlert]",  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
        )

    def post_alerts(self, alerts, **kwargs):  # noqa: E501
        """post_alerts  # noqa: E501

        Create new Alerts  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_alerts(alerts, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param list[PostableAlert] alerts: The alerts to create (required)
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        return self.post_alerts_with_http_info(alerts, **kwargs)  # noqa: E501

    def post_alerts_with_http_info(self, alerts, **kwargs):  # noqa: E501
        """post_alerts  # noqa: E501

        Create new Alerts  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_alerts_with_http_info(alerts, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param list[PostableAlert] alerts: The alerts to create (required)
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ["alerts"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method post_alerts" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]
        # verify the required parameter 'alerts' is set
        if self.api_client.client_side_validation and (
            "alerts" not in local_var_params or local_var_params["alerts"] is None  # noqa: E501
        ):  # noqa: E501
            raise ApiValueError("Missing the required parameter `alerts` when calling `post_alerts`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if "alerts" in local_var_params:
            body_params = local_var_params["alerts"]
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["application/json"])  # noqa: E501

        # HTTP header `Content-Type`
        header_params["Content-Type"] = self.api_client.select_header_content_type(  # noqa: E501
            ["application/json"]
        )  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            "/alerts",
            "POST",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
        )
