# coding: utf-8

"""
    Alertmanager API

    API of the Prometheus Alertmanager (https://github.com/prometheus/alertmanager)  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from prometheus_icinga_exporter.alertmanager_client.configuration import Configuration


class AlertmanagerStatus(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "cluster": "ClusterStatus",
        "version_info": "VersionInfo",
        "config": "AlertmanagerConfig",
        "uptime": "datetime",
    }

    attribute_map = {"cluster": "cluster", "version_info": "versionInfo", "config": "config", "uptime": "uptime"}

    def __init__(
        self, cluster=None, version_info=None, config=None, uptime=None, local_vars_configuration=None
    ):  # noqa: E501
        """AlertmanagerStatus - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._cluster = None
        self._version_info = None
        self._config = None
        self._uptime = None
        self.discriminator = None

        self.cluster = cluster
        self.version_info = version_info
        self.config = config
        self.uptime = uptime

    @property
    def cluster(self):
        """Gets the cluster of this AlertmanagerStatus.  # noqa: E501


        :return: The cluster of this AlertmanagerStatus.  # noqa: E501
        :rtype: ClusterStatus
        """
        return self._cluster

    @cluster.setter
    def cluster(self, cluster):
        """Sets the cluster of this AlertmanagerStatus.


        :param cluster: The cluster of this AlertmanagerStatus.  # noqa: E501
        :type: ClusterStatus
        """
        if self.local_vars_configuration.client_side_validation and cluster is None:  # noqa: E501
            raise ValueError("Invalid value for `cluster`, must not be `None`")  # noqa: E501

        self._cluster = cluster

    @property
    def version_info(self):
        """Gets the version_info of this AlertmanagerStatus.  # noqa: E501


        :return: The version_info of this AlertmanagerStatus.  # noqa: E501
        :rtype: VersionInfo
        """
        return self._version_info

    @version_info.setter
    def version_info(self, version_info):
        """Sets the version_info of this AlertmanagerStatus.


        :param version_info: The version_info of this AlertmanagerStatus.  # noqa: E501
        :type: VersionInfo
        """
        if self.local_vars_configuration.client_side_validation and version_info is None:  # noqa: E501
            raise ValueError("Invalid value for `version_info`, must not be `None`")  # noqa: E501

        self._version_info = version_info

    @property
    def config(self):
        """Gets the config of this AlertmanagerStatus.  # noqa: E501


        :return: The config of this AlertmanagerStatus.  # noqa: E501
        :rtype: AlertmanagerConfig
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this AlertmanagerStatus.


        :param config: The config of this AlertmanagerStatus.  # noqa: E501
        :type: AlertmanagerConfig
        """
        if self.local_vars_configuration.client_side_validation and config is None:  # noqa: E501
            raise ValueError("Invalid value for `config`, must not be `None`")  # noqa: E501

        self._config = config

    @property
    def uptime(self):
        """Gets the uptime of this AlertmanagerStatus.  # noqa: E501


        :return: The uptime of this AlertmanagerStatus.  # noqa: E501
        :rtype: datetime
        """
        return self._uptime

    @uptime.setter
    def uptime(self, uptime):
        """Sets the uptime of this AlertmanagerStatus.


        :param uptime: The uptime of this AlertmanagerStatus.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and uptime is None:  # noqa: E501
            raise ValueError("Invalid value for `uptime`, must not be `None`")  # noqa: E501

        self._uptime = uptime

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AlertmanagerStatus):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AlertmanagerStatus):
            return True

        return self.to_dict() != other.to_dict()
