# coding: utf-8

"""
    Alertmanager API

    API of the Prometheus Alertmanager (https://github.com/prometheus/alertmanager)  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from prometheus_icinga_exporter.alertmanager_client.configuration import Configuration


class GettableAlert(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "annotations": "dict(str, str)",
        "receivers": "list[Receiver]",
        "fingerprint": "str",
        "starts_at": "datetime",
        "updated_at": "datetime",
        "ends_at": "datetime",
        "status": "AlertStatus",
        "labels": "dict(str, str)",
        "generator_url": "str",
    }

    attribute_map = {
        "annotations": "annotations",
        "receivers": "receivers",
        "fingerprint": "fingerprint",
        "starts_at": "startsAt",
        "updated_at": "updatedAt",
        "ends_at": "endsAt",
        "status": "status",
        "labels": "labels",
        "generator_url": "generatorURL",
    }

    def __init__(
        self,
        annotations=None,
        receivers=None,
        fingerprint=None,
        starts_at=None,
        updated_at=None,
        ends_at=None,
        status=None,
        labels=None,
        generator_url=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """GettableAlert - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._annotations = None
        self._receivers = None
        self._fingerprint = None
        self._starts_at = None
        self._updated_at = None
        self._ends_at = None
        self._status = None
        self._labels = None
        self._generator_url = None
        self.discriminator = None

        self.annotations = annotations
        self.receivers = receivers
        self.fingerprint = fingerprint
        self.starts_at = starts_at
        self.updated_at = updated_at
        self.ends_at = ends_at
        self.status = status
        self.labels = labels
        if generator_url is not None:
            self.generator_url = generator_url

    @property
    def annotations(self):
        """Gets the annotations of this GettableAlert.  # noqa: E501


        :return: The annotations of this GettableAlert.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._annotations

    @annotations.setter
    def annotations(self, annotations):
        """Sets the annotations of this GettableAlert.


        :param annotations: The annotations of this GettableAlert.  # noqa: E501
        :type: dict(str, str)
        """
        if self.local_vars_configuration.client_side_validation and annotations is None:  # noqa: E501
            raise ValueError("Invalid value for `annotations`, must not be `None`")  # noqa: E501

        self._annotations = annotations

    @property
    def receivers(self):
        """Gets the receivers of this GettableAlert.  # noqa: E501


        :return: The receivers of this GettableAlert.  # noqa: E501
        :rtype: list[Receiver]
        """
        return self._receivers

    @receivers.setter
    def receivers(self, receivers):
        """Sets the receivers of this GettableAlert.


        :param receivers: The receivers of this GettableAlert.  # noqa: E501
        :type: list[Receiver]
        """
        if self.local_vars_configuration.client_side_validation and receivers is None:  # noqa: E501
            raise ValueError("Invalid value for `receivers`, must not be `None`")  # noqa: E501

        self._receivers = receivers

    @property
    def fingerprint(self):
        """Gets the fingerprint of this GettableAlert.  # noqa: E501


        :return: The fingerprint of this GettableAlert.  # noqa: E501
        :rtype: str
        """
        return self._fingerprint

    @fingerprint.setter
    def fingerprint(self, fingerprint):
        """Sets the fingerprint of this GettableAlert.


        :param fingerprint: The fingerprint of this GettableAlert.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and fingerprint is None:  # noqa: E501
            raise ValueError("Invalid value for `fingerprint`, must not be `None`")  # noqa: E501

        self._fingerprint = fingerprint

    @property
    def starts_at(self):
        """Gets the starts_at of this GettableAlert.  # noqa: E501


        :return: The starts_at of this GettableAlert.  # noqa: E501
        :rtype: datetime
        """
        return self._starts_at

    @starts_at.setter
    def starts_at(self, starts_at):
        """Sets the starts_at of this GettableAlert.


        :param starts_at: The starts_at of this GettableAlert.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and starts_at is None:  # noqa: E501
            raise ValueError("Invalid value for `starts_at`, must not be `None`")  # noqa: E501

        self._starts_at = starts_at

    @property
    def updated_at(self):
        """Gets the updated_at of this GettableAlert.  # noqa: E501


        :return: The updated_at of this GettableAlert.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this GettableAlert.


        :param updated_at: The updated_at of this GettableAlert.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and updated_at is None:  # noqa: E501
            raise ValueError("Invalid value for `updated_at`, must not be `None`")  # noqa: E501

        self._updated_at = updated_at

    @property
    def ends_at(self):
        """Gets the ends_at of this GettableAlert.  # noqa: E501


        :return: The ends_at of this GettableAlert.  # noqa: E501
        :rtype: datetime
        """
        return self._ends_at

    @ends_at.setter
    def ends_at(self, ends_at):
        """Sets the ends_at of this GettableAlert.


        :param ends_at: The ends_at of this GettableAlert.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and ends_at is None:  # noqa: E501
            raise ValueError("Invalid value for `ends_at`, must not be `None`")  # noqa: E501

        self._ends_at = ends_at

    @property
    def status(self):
        """Gets the status of this GettableAlert.  # noqa: E501


        :return: The status of this GettableAlert.  # noqa: E501
        :rtype: AlertStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this GettableAlert.


        :param status: The status of this GettableAlert.  # noqa: E501
        :type: AlertStatus
        """
        if self.local_vars_configuration.client_side_validation and status is None:  # noqa: E501
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def labels(self):
        """Gets the labels of this GettableAlert.  # noqa: E501


        :return: The labels of this GettableAlert.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this GettableAlert.


        :param labels: The labels of this GettableAlert.  # noqa: E501
        :type: dict(str, str)
        """
        if self.local_vars_configuration.client_side_validation and labels is None:  # noqa: E501
            raise ValueError("Invalid value for `labels`, must not be `None`")  # noqa: E501

        self._labels = labels

    @property
    def generator_url(self):
        """Gets the generator_url of this GettableAlert.  # noqa: E501


        :return: The generator_url of this GettableAlert.  # noqa: E501
        :rtype: str
        """
        return self._generator_url

    @generator_url.setter
    def generator_url(self, generator_url):
        """Sets the generator_url of this GettableAlert.


        :param generator_url: The generator_url of this GettableAlert.  # noqa: E501
        :type: str
        """

        self._generator_url = generator_url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GettableAlert):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GettableAlert):
            return True

        return self.to_dict() != other.to_dict()
