# coding: utf-8

"""
    Alertmanager API

    API of the Prometheus Alertmanager (https://github.com/prometheus/alertmanager)  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from prometheus_icinga_exporter.alertmanager_client.configuration import Configuration


class PostableAlert(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "starts_at": "datetime",
        "ends_at": "datetime",
        "annotations": "dict(str, str)",
        "labels": "dict(str, str)",
        "generator_url": "str",
    }

    attribute_map = {
        "starts_at": "startsAt",
        "ends_at": "endsAt",
        "annotations": "annotations",
        "labels": "labels",
        "generator_url": "generatorURL",
    }

    def __init__(
        self,
        starts_at=None,
        ends_at=None,
        annotations=None,
        labels=None,
        generator_url=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """PostableAlert - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._starts_at = None
        self._ends_at = None
        self._annotations = None
        self._labels = None
        self._generator_url = None
        self.discriminator = None

        if starts_at is not None:
            self.starts_at = starts_at
        if ends_at is not None:
            self.ends_at = ends_at
        if annotations is not None:
            self.annotations = annotations
        self.labels = labels
        if generator_url is not None:
            self.generator_url = generator_url

    @property
    def starts_at(self):
        """Gets the starts_at of this PostableAlert.  # noqa: E501


        :return: The starts_at of this PostableAlert.  # noqa: E501
        :rtype: datetime
        """
        return self._starts_at

    @starts_at.setter
    def starts_at(self, starts_at):
        """Sets the starts_at of this PostableAlert.


        :param starts_at: The starts_at of this PostableAlert.  # noqa: E501
        :type: datetime
        """

        self._starts_at = starts_at

    @property
    def ends_at(self):
        """Gets the ends_at of this PostableAlert.  # noqa: E501


        :return: The ends_at of this PostableAlert.  # noqa: E501
        :rtype: datetime
        """
        return self._ends_at

    @ends_at.setter
    def ends_at(self, ends_at):
        """Sets the ends_at of this PostableAlert.


        :param ends_at: The ends_at of this PostableAlert.  # noqa: E501
        :type: datetime
        """

        self._ends_at = ends_at

    @property
    def annotations(self):
        """Gets the annotations of this PostableAlert.  # noqa: E501


        :return: The annotations of this PostableAlert.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._annotations

    @annotations.setter
    def annotations(self, annotations):
        """Sets the annotations of this PostableAlert.


        :param annotations: The annotations of this PostableAlert.  # noqa: E501
        :type: dict(str, str)
        """

        self._annotations = annotations

    @property
    def labels(self):
        """Gets the labels of this PostableAlert.  # noqa: E501


        :return: The labels of this PostableAlert.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this PostableAlert.


        :param labels: The labels of this PostableAlert.  # noqa: E501
        :type: dict(str, str)
        """
        if self.local_vars_configuration.client_side_validation and labels is None:  # noqa: E501
            raise ValueError("Invalid value for `labels`, must not be `None`")  # noqa: E501

        self._labels = labels

    @property
    def generator_url(self):
        """Gets the generator_url of this PostableAlert.  # noqa: E501


        :return: The generator_url of this PostableAlert.  # noqa: E501
        :rtype: str
        """
        return self._generator_url

    @generator_url.setter
    def generator_url(self, generator_url):
        """Sets the generator_url of this PostableAlert.


        :param generator_url: The generator_url of this PostableAlert.  # noqa: E501
        :type: str
        """

        self._generator_url = generator_url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PostableAlert):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PostableAlert):
            return True

        return self.to_dict() != other.to_dict()
