# coding: utf-8

"""
    Alertmanager API

    API of the Prometheus Alertmanager (https://github.com/prometheus/alertmanager)  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from prometheus_icinga_exporter.alertmanager_client.configuration import Configuration


class Silence(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "matchers": "list[Matcher]",
        "starts_at": "datetime",
        "ends_at": "datetime",
        "created_by": "str",
        "comment": "str",
    }

    attribute_map = {
        "matchers": "matchers",
        "starts_at": "startsAt",
        "ends_at": "endsAt",
        "created_by": "createdBy",
        "comment": "comment",
    }

    def __init__(
        self, matchers=None, starts_at=None, ends_at=None, created_by=None, comment=None, local_vars_configuration=None
    ):  # noqa: E501
        """Silence - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._matchers = None
        self._starts_at = None
        self._ends_at = None
        self._created_by = None
        self._comment = None
        self.discriminator = None

        self.matchers = matchers
        self.starts_at = starts_at
        self.ends_at = ends_at
        self.created_by = created_by
        self.comment = comment

    @property
    def matchers(self):
        """Gets the matchers of this Silence.  # noqa: E501


        :return: The matchers of this Silence.  # noqa: E501
        :rtype: list[Matcher]
        """
        return self._matchers

    @matchers.setter
    def matchers(self, matchers):
        """Sets the matchers of this Silence.


        :param matchers: The matchers of this Silence.  # noqa: E501
        :type: list[Matcher]
        """
        if self.local_vars_configuration.client_side_validation and matchers is None:  # noqa: E501
            raise ValueError("Invalid value for `matchers`, must not be `None`")  # noqa: E501

        self._matchers = matchers

    @property
    def starts_at(self):
        """Gets the starts_at of this Silence.  # noqa: E501


        :return: The starts_at of this Silence.  # noqa: E501
        :rtype: datetime
        """
        return self._starts_at

    @starts_at.setter
    def starts_at(self, starts_at):
        """Sets the starts_at of this Silence.


        :param starts_at: The starts_at of this Silence.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and starts_at is None:  # noqa: E501
            raise ValueError("Invalid value for `starts_at`, must not be `None`")  # noqa: E501

        self._starts_at = starts_at

    @property
    def ends_at(self):
        """Gets the ends_at of this Silence.  # noqa: E501


        :return: The ends_at of this Silence.  # noqa: E501
        :rtype: datetime
        """
        return self._ends_at

    @ends_at.setter
    def ends_at(self, ends_at):
        """Sets the ends_at of this Silence.


        :param ends_at: The ends_at of this Silence.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and ends_at is None:  # noqa: E501
            raise ValueError("Invalid value for `ends_at`, must not be `None`")  # noqa: E501

        self._ends_at = ends_at

    @property
    def created_by(self):
        """Gets the created_by of this Silence.  # noqa: E501


        :return: The created_by of this Silence.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this Silence.


        :param created_by: The created_by of this Silence.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and created_by is None:  # noqa: E501
            raise ValueError("Invalid value for `created_by`, must not be `None`")  # noqa: E501

        self._created_by = created_by

    @property
    def comment(self):
        """Gets the comment of this Silence.  # noqa: E501


        :return: The comment of this Silence.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this Silence.


        :param comment: The comment of this Silence.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and comment is None:  # noqa: E501
            raise ValueError("Invalid value for `comment`, must not be `None`")  # noqa: E501

        self._comment = comment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Silence):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Silence):
            return True

        return self.to_dict() != other.to_dict()
